/*********************************************************************
 *	traoR̃^[Qbg[ANZX
 *********************************************************************
 *`oh:
int		UsbInit(int verbose,int enable_bulk);			.
int		UsbExit(void);									I.
void 	UsbBench(int cnt,int psize);					x`}[N

void 	UsbPoke(int adr,int arena,int data,int mask);	
int 	UsbPeek(int adr,int arena);						PoCgǂݏo
int 	UsbRead(int adr,int arena,uchar *buf,int size);	Aǂݏo
void	UsbDump(int adr,int arena,int size);			[_v
 *
 *֐:
void	dumpmem(int adr,int cnt);
void	pokemem(int adr,int data0,int data1);
void	memdump_print(void *ptr,int len,int off);
 */

#include <windows.h>
#include <stdio.h>
#include <time.h>

#include "hidasp.h"
#include "monit.h"
#include "util.h"

#define	VERBOSE	0

#define	if_V	if(VERBOSE)

static	char verbose_mode = 0;
static  int  HidLength1 = 7;
static  int  HidLength  = 31;

/****************************************************************************
 *	[e_v.
 ****************************************************************************
 *	void *ptr : _vf[^.
 *	int   len : _voCg.
 *	int   off : ^[Qbg̔Ԓn\.
 */
void memdump_print(void *ptr,int len,int off)
{
	unsigned char *p = (unsigned char *)ptr;
	int i,j,c;

	for(i=0;i<len;i++) {
		if( (i & 15) == 0 ) printf("%06x",(int)p - (int)ptr + off);
		printf(" %02x",*p);p++;
		if( (i & 15) == 15 )
		{
#if	1	// ASCII DUMP
			printf("  ");
			for(j=0;j<16;j++) {
				c=p[j-16];
				if(c<' ') c='.';
				if(c>=0x7f) c='.';
				printf("%c",c);
			}
#endif
			printf("\n");
		}
	}
	printf("\n");
}



/*********************************************************************
 *	`uqfoCXɏR}h𑗂āAKvȂ猋ʂ󂯎.
 *********************************************************************
 *	cmdBuf   *cmd : R}h
 *	uchar    *buf : ʂ󂯎̈.
 *  int reply_len : ʂ̕KvTCY. (0̏ꍇ͌ʂ󂯎Ȃ)
 *߂l
 *		0	: s
 *	   !0   : 
 */
int QueryAVR(cmdBuf *cmd,uchar *buf,int reply_len)
{
	int rc = 0;
	int size = cmd->size;
	char *s;
	rc = hidWriteBuffer((char*) cmd , HidLength1 );
	if(rc == 0) {
		printf("hidWrite error\n");
		exit(1);
	}
	if(reply_len) {
		rc = hidReadBuffer((char *)cmd , reply_len );
		if(rc == 0) {
			printf("hidRead error\n");
			exit(1);
		}
		s = (char*) cmd;
		memcpy(buf, s+1 ,size);
	}
    return rc;
}
/*********************************************************************
 *	^[Qbg̃[e擾
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           size :ǂݎTCY.
 *	unsigned char *buf :󂯎obt@.
 *	ӁF HID Report Length - 1 蒷TCY͗vĂ͂ȂȂ.
 */
int dumpmem(int adr,int arena,int size,unsigned char *buf)
{
	cmdBuf cmd;

	memset(&cmd,0,sizeof(cmdBuf));
	cmd.cmd   = CMD_PEEK ;	//| arena;
	cmd.size  = size;
	cmd.adr[0]= adr;
	cmd.adr[1]= adr>>8;

	if( QueryAVR(&cmd,buf,1+size) == 0) return 0;	//s.
	return size;
}
/*********************************************************************
 *	^[Qbg̃[eiPoCgj.
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int          data0 :݃f[^.      (OR)
 *	int          data1 :݃rbg}XN.(AND)
 *:
 *	t@[̏݃ASY͈ȉ̂悤ɂȂĂ̂Œ. 

	if(data1) {	//}XNt̏.
		*adr = (*adr & data1) | data0;
	}else{			//ׂ.
		*adr = data0;
	}

 */
void pokemem(int adr,int arena,int data0,int data1)
{
    cmdBuf cmd;
	char buf[16];	// dummy

	memset(&cmd,0,sizeof(cmdBuf));
	cmd.cmd   = CMD_POKE ;	//| arena;
	cmd.size  = 1;
	cmd.adr[0]= adr;
	cmd.adr[1]= adr>>8;
	cmd.data[0] = data0;
	cmd.data[1] = data1;
	QueryAVR(&cmd,buf,0);
}

/*********************************************************************
 *	^[QbgƂ̐ڑ`FbNix`}[N˂j
 *********************************************************************
 *	int i : 0`255 ̐l.
 *߂l
 *		GR[obNꂽ i ̒l.
 */
int hid_ping(int i)
{
 	cmdBuf cmd;
	char buf[128];	// dummy
	int rc;

	memset(&cmd,i,sizeof(cmdBuf));
	cmd.cmd   = CMD_PING ;
	QueryAVR(&cmd,buf,0);

	rc = hidReadBuffer(buf , HidLength );
	if(rc == 0) {
		printf("hidRead error\n");
		exit(1);
	}
	return buf[2] & 0xff;
}
/*********************************************************************
 *	]xx`}[N
 *********************************************************************
 *	int cnt  : PINGł.
 *	int psize: PINGpPbg̑傫(݂̓T|[gȂ)
 */
void UsbBench(int cnt,int psize)
{
	int i,n,rc;
	int time1, rate;
	int total=0;
	int nBytes  = HidLength1 + HidLength ;	//݌Œ.
	// PPing 7byteQuery31oCg̃^[.

   	printf("hid write start\n");
	int time0 = clock();

	for(i=0;i<cnt;i++) {
		n = i & 0xff;
		rc = hid_ping(n);
		if(rc != n) {
			printf("hid ping mismatch error (%x != %x)\n",rc,n);
			exit(1);
		}
		total += nBytes;
	}

	time1 = clock() - time0;
	if (time1 == 0) {
		time1 = 2;
	}
	rate = total * 1000 / time1;

   	printf("hid write end, %d bytes/%d ms,  %d bytes/s\n",total,time1,rate);
}
/*********************************************************************
 *	^[Qbg[_v.
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int            cnt :ǂݎTCY.
 */
void UsbDump(int adr,int arena,int cnt)
{
	unsigned char buf[16];
	int size;
	int rc;
	while(cnt) {
		size = cnt;
		if(size>=8) size = 8;
		rc = dumpmem(adr,arena,size,buf);	//[e̓ǂݏo.

		if(rc !=size) return;
		memdump_print(buf,size,adr);		//ʈ.
		adr += size;
		cnt -= size;
	}
}
/*********************************************************************
 *	^[Qbg[Aǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	uchar         *buf :ǂݎobt@.
 *	int           size :ǂݎTCY.
 *߂l
 *	-1    : s
 *	̒l: .
 */
int UsbRead(int adr,int arena,uchar *buf,int size)
{
	int rc = size;
	int len;
	while(size) {
		len = size;
		if(len >= 8) len = 8;
		int rc = dumpmem(adr,arena,len,buf);
		if( rc!= len) {
			return -1;
		}
		adr  += len;	// ^[QbgAhXi߂.
		buf  += len;	// ǂݍݐobt@i߂.
		size -= len; 	// cTCY炷.
	}
	return rc;
}
/*********************************************************************
 *	^[Qbg[PoCgǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbPeek(int adr,int arena)
{
	unsigned char buf[16];
	int size=1;
	int rc = UsbRead(adr,arena,buf,size);
	if( rc != size) {
		return -1;
	}
	return buf[0];
}
/*********************************************************************
 *	^[Qbg̃[eiPoCgj.
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           data :݃f[^.
 *	int           mask :ݗLrbg}XN.
 *
 *  mask  = 0 ̏ꍇ͑SrbgL ()
 *	mask != 0 ̏ꍇ́Amaskrbg1ɑΉdatâݍXVA͕ύXȂ.
 */
void UsbPoke(int adr,int arena,int data,int mask)
{
	int data0 ,data1;
	if(mask == 0) {
		// }XNsv̒.
		data0 = data;
		data1 = 0;
	}else{
		// }XN܂ޏ.
		// ݃f[^̗L mask ̃rbg 1 ɂȂĂ镔̂.
		// mask ̃rbg 0 ł镔́Ȁێ.

		data0 = data & mask;	// OR.
		data1 = 0xff &(~mask);	// AND.

		// }XÑ݂WbN͈ȉ.
		// *mem = (*mem & data1) | data0;
	}

	pokemem(adr,arena,data0,data1);
}
/*********************************************************************
 *	Prbg̏
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int            bit :݃f[^i1bitj 0  1
 *	int           mask :ݗLrbg}XN.
 */
void UsbPoke_b(int adr,int arena,int bit,int mask)
{
	int data=0;
	if(mask == 0) {
		//PoCg̏.
		UsbPoke(adr,arena,bit,0);
	}else{
		//Prbg̏.
		if(bit) data = 0xff;
		UsbPoke(adr,arena,data,mask);
	}
}
/*********************************************************************
 *	
 *********************************************************************
 */
int UsbInit(int verbose,int enable_bulk)
{
	verbose_mode = verbose;
	if(	hidasp_init(NULL) != 0) {
    	printf("error: device not found!\n");
    	return 0;
	}
	return 1;	// OK.
}



/*********************************************************************
 *	I
 *********************************************************************
 */
int UsbExit(void)
{
	hidasp_close();
	return 0;
}
/*********************************************************************
 *	gp֐
 *********************************************************************
 */

void report_update(int l)
{
}
